diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/uan/CMakeLists.txt ns-3.36/src/uan/CMakeLists.txt
--- ns-3.35/src/uan/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/uan/CMakeLists.txt	2022-04-30 18:23:58.170735000 -0700
@@ -0,0 +1,57 @@
+build_lib(
+  LIBNAME uan
+  SOURCE_FILES
+    helper/acoustic-modem-energy-model-helper.cc
+    helper/uan-helper.cc
+    model/acoustic-modem-energy-model.cc
+    model/uan-channel.cc
+    model/uan-header-common.cc
+    model/uan-header-rc.cc
+    model/uan-mac-aloha.cc
+    model/uan-mac-cw.cc
+    model/uan-mac-rc-gw.cc
+    model/uan-mac-rc.cc
+    model/uan-mac.cc
+    model/uan-net-device.cc
+    model/uan-noise-model-default.cc
+    model/uan-noise-model.cc
+    model/uan-phy-dual.cc
+    model/uan-phy-gen.cc
+    model/uan-phy.cc
+    model/uan-prop-model-ideal.cc
+    model/uan-prop-model-thorp.cc
+    model/uan-prop-model.cc
+    model/uan-transducer-hd.cc
+    model/uan-transducer.cc
+    model/uan-tx-mode.cc
+  HEADER_FILES
+    helper/acoustic-modem-energy-model-helper.h
+    helper/uan-helper.h
+    model/acoustic-modem-energy-model.h
+    model/uan-channel.h
+    model/uan-header-common.h
+    model/uan-header-rc.h
+    model/uan-mac-aloha.h
+    model/uan-mac-cw.h
+    model/uan-mac-rc-gw.h
+    model/uan-mac-rc.h
+    model/uan-mac.h
+    model/uan-net-device.h
+    model/uan-noise-model-default.h
+    model/uan-noise-model.h
+    model/uan-phy-dual.h
+    model/uan-phy-gen.h
+    model/uan-phy.h
+    model/uan-prop-model-ideal.h
+    model/uan-prop-model-thorp.h
+    model/uan-prop-model.h
+    model/uan-transducer-hd.h
+    model/uan-transducer.h
+    model/uan-tx-mode.h
+  LIBRARIES_TO_LINK
+    ${libnetwork}
+    ${libmobility}
+    ${libenergy}
+  TEST_SOURCES test/uan-energy-model-test.cc
+               test/uan-test.cc
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/uan/examples/CMakeLists.txt ns-3.36/src/uan/examples/CMakeLists.txt
--- ns-3.35/src/uan/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/uan/examples/CMakeLists.txt	2022-04-30 18:23:58.174735000 -0700
@@ -0,0 +1,34 @@
+set(base_examples
+    uan-cw-example
+    uan-rc-example
+    uan-ipv4-example
+    uan-ipv6-example
+    uan-raw-example
+)
+foreach(
+  example
+  ${base_examples}
+)
+  build_lib_example(
+    NAME ${example}
+    SOURCE_FILES ${example}.cc
+    LIBRARIES_TO_LINK
+      ${libinternet}
+      ${libmobility}
+      ${libstats}
+      ${libapplications}
+      ${libuan}
+  )
+endforeach()
+
+build_lib_example(
+  NAME uan-6lowpan-example
+  SOURCE_FILES uan-6lowpan-example.cc
+  LIBRARIES_TO_LINK
+    ${libinternet}
+    ${libmobility}
+    ${libstats}
+    ${libapplications}
+    ${libuan}
+    ${libsixlowpan}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/uan/helper/uan-helper.cc ns-3.36/src/uan/helper/uan-helper.cc
--- ns-3.35/src/uan/helper/uan-helper.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/uan/helper/uan-helper.cc	2022-04-30 18:23:58.174735000 -0700
@@ -55,9 +55,9 @@
  * \param mode The transmission mode.
  */
 static void AsciiPhyTxEvent (std::ostream *os, std::string context,
-                             Ptr<const Packet> packet, double txPowerDb, UanTxMode mode)
+                             Ptr<const Packet> packet, 
+                             [[maybe_unused]] double txPowerDb, UanTxMode mode)
 {
-  NS_UNUSED (txPowerDb);
   *os << "+ " << Simulator::Now ().GetSeconds () << " " << context << " " << *packet << std::endl;
 }
 
@@ -71,9 +71,9 @@
  * \param mode The channel transmission mode.
  */
 static void AsciiPhyRxOkEvent (std::ostream *os, std::string context,
-                               Ptr<const Packet> packet, double snr, UanTxMode mode)
+                               Ptr<const Packet> packet, 
+                               [[maybe_unused]] double snr, UanTxMode mode)
 {
-  NS_UNUSED (snr);
   *os << "r " << Simulator::Now ().GetSeconds () << " " << context << " " << *packet << std::endl;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/uan/model/uan-mac-aloha.cc ns-3.36/src/uan/model/uan-mac-aloha.cc
--- ns-3.35/src/uan/model/uan-mac-aloha.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/uan/model/uan-mac-aloha.cc	2022-04-30 18:23:58.174735000 -0700
@@ -114,9 +114,8 @@
 
 }
 void
-UanMacAloha::RxPacketGood (Ptr<Packet> pkt, double sinr, UanTxMode txMode)
+UanMacAloha::RxPacketGood (Ptr<Packet> pkt, [[maybe_unused]] double sinr, UanTxMode txMode)
 {
-  NS_UNUSED (sinr);
   UanHeaderCommon header;
   pkt->RemoveHeader (header);
   NS_LOG_DEBUG ("Receiving packet from " << header.GetSrc () << " For " << header.GetDest ());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/uan/model/uan-mac-cw.cc ns-3.36/src/uan/model/uan-mac-cw.cc
--- ns-3.35/src/uan/model/uan-mac-cw.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/uan/model/uan-mac-cw.cc	2022-04-30 18:23:58.174735000 -0700
@@ -326,9 +326,8 @@
   return m_slotTime;
 }
 void
-UanMacCw::PhyRxPacketGood (Ptr<Packet> packet, double sinr, UanTxMode mode)
+UanMacCw::PhyRxPacketGood (Ptr<Packet> packet, [[maybe_unused]] double sinr, UanTxMode mode)
 {
-  NS_UNUSED (sinr);
   UanHeaderCommon header;
   packet->RemoveHeader (header);
 
@@ -338,9 +337,8 @@
     }
 }
 void
-UanMacCw::PhyRxPacketError (Ptr<Packet> packet, double sinr)
+UanMacCw::PhyRxPacketError (Ptr<Packet> packet, [[maybe_unused]] double sinr)
 {
-  NS_UNUSED (sinr);
 }
 void
 UanMacCw::SaveTimer (void)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/uan/model/uan-mac-rc.cc ns-3.36/src/uan/model/uan-mac-rc.cc
--- ns-3.35/src/uan/model/uan-mac-rc.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/uan/model/uan-mac-rc.cc	2022-04-30 18:23:58.174735000 -0700
@@ -144,9 +144,8 @@
 }
 
 void
-Reservation::SetTransmitted (bool t)
+Reservation::SetTransmitted ([[maybe_unused]] bool t)
 {
-  NS_UNUSED (t);
   m_transmitted = true;
 }
 
@@ -326,9 +325,8 @@
 }
 
 void
-UanMacRc::ReceiveOkFromPhy (Ptr<Packet> pkt, double sinr, UanTxMode mode)
+UanMacRc::ReceiveOkFromPhy (Ptr<Packet> pkt, [[maybe_unused]] double sinr, UanTxMode mode)
 {
-  NS_UNUSED (sinr);
   UanHeaderCommon ch;
   pkt->RemoveHeader (ch);
   if (ch.GetDest () == Mac8Address::ConvertFrom (GetAddress ()) || ch.GetDest () == Mac8Address::GetBroadcast ())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/uan/model/uan-mac-rc-gw.cc ns-3.36/src/uan/model/uan-mac-rc-gw.cc
--- ns-3.35/src/uan/model/uan-mac-rc-gw.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/uan/model/uan-mac-rc-gw.cc	2022-04-30 18:23:58.174735000 -0700
@@ -171,10 +171,10 @@
 }
 
 bool
-UanMacRcGw::Enqueue (Ptr<Packet> packet, uint16_t protocolNumber, const Address &dest)
+UanMacRcGw::Enqueue (Ptr<Packet> packet, 
+                     [[maybe_unused]] uint16_t protocolNumber, 
+                     [[maybe_unused]] const Address &dest)
 {
-  NS_UNUSED (dest);
-  NS_UNUSED (protocolNumber);
   NS_LOG_WARN ("RCMAC Gateway transmission to acoustic nodes is not yet implemented");
   return false;
 }
@@ -194,15 +194,13 @@
 }
 
 void
-UanMacRcGw::ReceiveError (Ptr<Packet> pkt, double sinr)
+UanMacRcGw::ReceiveError (Ptr<Packet> pkt, [[maybe_unused]] double sinr)
 {
-  NS_UNUSED (sinr);
 }
 
 void
-UanMacRcGw::ReceivePacket (Ptr<Packet> pkt, double sinr, UanTxMode mode)
+UanMacRcGw::ReceivePacket (Ptr<Packet> pkt, [[maybe_unused]] double sinr, UanTxMode mode)
 {
-  NS_UNUSED (sinr);
   UanHeaderCommon ch;
   pkt->PeekHeader (ch);
 
@@ -536,9 +534,9 @@
 
 
 double
-UanMacRcGw::ComputeAlpha (uint32_t totalFrames, uint32_t totalBytes, uint32_t n, uint32_t a, double deltaK)
+UanMacRcGw::ComputeAlpha (uint32_t totalFrames, uint32_t totalBytes, 
+                          [[maybe_unused]] uint32_t n, uint32_t a, double deltaK)
 {
-  NS_UNUSED (n);
   double alpha;
   double lrae = m_rtsSize * 8.0 * a * std::exp (1.0);
   if (totalFrames == 0)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/uan/model/uan-net-device.cc ns-3.36/src/uan/model/uan-net-device.cc
--- ns-3.35/src/uan/model/uan-net-device.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/uan/model/uan-net-device.cc	2022-04-30 18:23:58.178735000 -0700
@@ -275,9 +275,8 @@
 }
 
 Address
-UanNetDevice::GetMulticast (Ipv4Address multicastGroup) const
+UanNetDevice::GetMulticast ([[maybe_unused]] Ipv4Address multicastGroup) const
 {
-  NS_UNUSED (multicastGroup);
   return m_mac->GetBroadcast ();
 }
 
@@ -309,11 +308,11 @@
 }
 
 bool
-UanNetDevice::SendFrom (Ptr<Packet> packet, const Address& source, const Address& dest, uint16_t protocolNumber)
+UanNetDevice::SendFrom (Ptr<Packet> packet, 
+                        [[maybe_unused]] const Address& source, 
+                        [[maybe_unused]] const Address& dest, 
+                        [[maybe_unused]] uint16_t protocolNumber)
 {
-  NS_UNUSED (source);
-  NS_UNUSED (dest);
-  NS_UNUSED (protocolNumber);
   // Not yet implemented
   NS_ASSERT_MSG (0, "Not yet implemented");
   return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/uan/model/uan-phy-dual.cc ns-3.36/src/uan/model/uan-phy-dual.cc
--- ns-3.35/src/uan/model/uan-phy-dual.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/uan/model/uan-phy-dual.cc	2022-04-30 18:23:58.178735000 -0700
@@ -273,9 +273,8 @@
 }
 
 void
-UanPhyDual::StartRxPacket (Ptr<Packet> pkt, double rxPowerDb, UanTxMode txMode, UanPdp pdp)
+UanPhyDual::StartRxPacket (Ptr<Packet> pkt, [[maybe_unused]] double rxPowerDb, UanTxMode txMode, UanPdp pdp)
 {
-  NS_UNUSED (rxPowerDb);
   // Not called.  StartRxPacket in m_phy1 and m_phy2 are called directly from Transducer.
 }
 
@@ -484,9 +483,8 @@
   m_phy2->SetMac (mac);
 }
 void
-UanPhyDual::NotifyTransStartTx (Ptr<Packet> packet, double txPowerDb, UanTxMode txMode)
+UanPhyDual::NotifyTransStartTx (Ptr<Packet> packet, [[maybe_unused]] double txPowerDb, UanTxMode txMode)
 {
-  NS_UNUSED (txPowerDb);
 }
 void
 UanPhyDual::NotifyIntChange (void)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/uan/model/uan-phy-dual.h ns-3.36/src/uan/model/uan-phy-dual.h
--- ns-3.35/src/uan/model/uan-phy-dual.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/uan/model/uan-phy-dual.h	2022-04-30 18:23:58.178735000 -0700
@@ -135,9 +135,8 @@
   virtual uint32_t GetNModes (void);
   virtual UanTxMode GetMode (uint32_t n);
   virtual void Clear (void);
-  virtual void SetSleepMode (bool sleep)
+  virtual void SetSleepMode ([[maybe_unused]] bool sleep)
   {
-    NS_UNUSED (sleep);
     /// \todo This method has to be implemented
   }
   int64_t AssignStreams (int64_t stream);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/uan/model/uan-phy-gen.cc ns-3.36/src/uan/model/uan-phy-gen.cc
--- ns-3.35/src/uan/model/uan-phy-gen.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/uan/model/uan-phy-gen.cc	2022-04-30 18:23:58.178735000 -0700
@@ -831,9 +831,8 @@
 }
 
 void
-UanPhyGen::RxEndEvent (Ptr<Packet> pkt, double rxPowerDb, UanTxMode txMode)
+UanPhyGen::RxEndEvent (Ptr<Packet> pkt, [[maybe_unused]] double rxPowerDb, UanTxMode txMode)
 {
-  NS_UNUSED (rxPowerDb);
   if (pkt != m_pktRx)
     {
       return;
@@ -1041,9 +1040,8 @@
 }
 
 void
-UanPhyGen::NotifyTransStartTx (Ptr<Packet> packet, double txPowerDb, UanTxMode txMode)
+UanPhyGen::NotifyTransStartTx (Ptr<Packet> packet, [[maybe_unused]] double txPowerDb, UanTxMode txMode)
 {
-  NS_UNUSED (txPowerDb);
   if (m_pktRx)
     {
       m_minRxSinrDb = -1e30;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/uan/test/uan-energy-model-test.cc ns-3.36/src/uan/test/uan-energy-model-test.cc
--- ns-3.35/src/uan/test/uan-energy-model-test.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/uan/test/uan-energy-model-test.cc	2022-04-30 18:23:58.178735000 -0700
@@ -116,10 +116,10 @@
 }
 
 bool
-AcousticModemEnergyTestCase::RxPacket (Ptr<NetDevice> dev, Ptr<const Packet> pkt, uint16_t mode, const Address &sender)
+AcousticModemEnergyTestCase::RxPacket (Ptr<NetDevice> dev, Ptr<const Packet> pkt, 
+                                       [[maybe_unused]] uint16_t mode, 
+                                       [[maybe_unused]] const Address &sender)
 {
-  NS_UNUSED (mode);
-  NS_UNUSED (sender);
   // increase the total bytes received
   m_bytesRx += pkt->GetSize ();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/uan/test/uan-test.cc ns-3.36/src/uan/test/uan-test.cc
--- ns-3.35/src/uan/test/uan-test.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/uan/test/uan-test.cc	2022-04-30 18:23:58.178735000 -0700
@@ -98,10 +98,10 @@
 }
 
 bool
-UanTest::RxPacket (Ptr<NetDevice> dev, Ptr<const Packet> pkt, uint16_t mode, const Address &sender)
+UanTest::RxPacket (Ptr<NetDevice> dev, Ptr<const Packet> pkt, 
+                   [[maybe_unused]] uint16_t mode, 
+                   [[maybe_unused]] const Address &sender)
 {
-  NS_UNUSED (mode);
-  NS_UNUSED (sender);
   m_bytesRx += pkt->GetSize ();
   return true;
 }
